
#include 'dll.ch'
#include 'xbp.ch'
#include "Gra.ch"
#include "Appevent.ch"
#include 'font.ch'

#define WM_GETICON      0x7F
#define GW_HWNDNEXT     2

#define FarbeBG         GraMakeRGBColor({255,242,229})

STATIC DLLFUNCTION BringWindowToTop( nHwnd )                     USING STDCALL FROM USER32.DLL
STATIC DLLFUNCTION SetForegroundWindow( nHwnd )                  USING STDCALL FROM USER32.DLL
STATIC DLLFUNCTION ShowWindow( nHwnd, nCmdShow )                 USING STDCALL FROM USER32.DLL
STATIC DLLFUNCTION IsIconic( nHwnd )                             USING STDCALL FROM USER32.DLL
STATIC DLLFUNCTION SendMessageA( nHwnd, nMsg, wParam, lParam )   USING STDCALL FROM USER32.DLL
STATIC DLLFUNCTION DrawIcon( nHDC, nX, nY, nHIcon )              USING STDCALL FROM USER32.DLL
STATIC DLLFUNCTION GetWindowDC( nHwnd )                          USING STDCALL FROM USER32.DLL
STATIC DLLFUNCTION ReleaseDC( nHwnd, nHDC )                      USING STDCALL FROM USER32.DLL
STATIC DLLFUNCTION GetClassLongA( nHwnd, nIndex )                USING STDCALL FROM USER32.DLL
STATIC DLLFUNCTION LoadIconA( hInstance, lpIconName )            USING STDCALL FROM USER32.DLL

////////////////////////////////////////////////////////////////////////
PROCEDURE AppSys()
RETURN

PROCEDURE dbeSys()
RETURN

////////////////////////////////////////////////////////////////////////
PROCEDURE Main()
LOCAL aHandles:={},  n, aPrograms:={}, cProgram, nHandle:=0
LOCAL nEvent:=nil, mp1:=nil, mp2:=nil, oXbp:=nil
LOCAL aPos, aSize, oDlg, oBut, oBox
LOCAL aButtons := {}
LOCAL aPicture := {}
LOCAL aDummy   := {}

   aSize :={395,AppDesktop():CurrentSize()[2]-100}
   aSize :={0,0}
   aPos  :=CenterWin(aSize)

   oDlg  := XbpDialog():new(,, aPos, aSize, , .F.)
   oDlg:taskList  := .t.
   oDlg:Border    :=XBPDLG_RAISEDBORDERTHICK_FIXED
   oDlg:taskList  := .T.
   oDlg:titlebar  := .F.
   oDlg:title     := "Tasks"
   oDlg:icon      := 2
   oDlg:resize    := {| aOldSize, aNewSize, oSelf | MainResize(aOldSize, aNewSize, oSelf) }
   oDlg:minButton := .F.
   oDlg:maxButton := .F.
   oDlg:create()
   oDlg:show()
   oDlg:drawingarea:setcolorBG(FarbeBG)
   oDlg:configure()

   aHandles := GetTaskList( oDlg:gethWnd( ) )

ALTD()

   FOR n:=1 TO len(aHandles)
      nHandle  := VAL(SUBSTR( aHandles[ n ],1,9 ))

      cProgram := TRIM( UPPER( SUBSTR( aHandles[ n ], 9 ) ) )
      cProgram := SUBSTR( cProgram, 1, LEN( cProgram ) - 1 )

      IF !EMPTY(cProgram)  .and. cProgram!='PROGRAM MANAGER'
         IF cProgram = "TASKS"
            AADD(aDummy,{nHandle,cProgram,FindIcon(nHandle)})
         ELSE
            AADD(aPrograms,{nHandle,cProgram,FindIcon(nHandle)})
         ENDIF
      ENDIF
   NEXT n

   IF LEN(aPrograms)==0
      Msgbox('No active tasks')
      RETURN
   ENDIF

   ASORT( aPrograms,,, {|aX,aY| UPPER(aX[2]) < UPPER(aY[2]) } )

   oDlg:setModalState( XBP_DISP_APPMODAL )

   FOR n:=LEN(aPrograms) TO 1 STEP -1
      aPos  := {70,oDlg:currentsize()[2]-(47*n)-15}
      aSize := {310,32+15}
      oBut:=XbpPushbutton():new( oDlg:drawingArea, , aPos,{310,32+15} )
      oBut:setfontcompoundname('10.Arial')
      oBut:cargo:=n
      oBut:activate:={ |mp1,mp2,obj| nHandle:=aPrograms[obj:cargo,1], PostAppEvent(xbeP_Close,,,oDlg) }
      oBut:caption:=aPrograms[n,2]
      oBut:tabstop:=.t.
      oBut:create()

      AADD(aButtons,oBut)

      aPos  := {5,oDlg:currentsize()[2]-(47*n)-15}
      aSize := {60,32+15}
      oBox:=XbpStatic():new( oDlg:drawingArea, , aPos,aSize )
      oBox:type:=XBPSTATIC_TYPE_RAISEDBOX
      oBox:paint:={ || ShowIcons(aPrograms,oDlg) }
      oBox:create()

      AADD(aPicture,oBox)

   next n

   IF EMPTY(aDummy)
   ELSE
      AADD(aPrograms,{aDummy[1,1],aDummy[1,2],aDummy[1,3]})
   ENDIF

   aPos  := {70,4}
   aSize := {310,32+15}

   oBut:=XbpPushbutton():new( oDlg:drawingArea, , aPos,aSize )
   oBut:setfontcompoundname('16.Arial')
   oBut:activate:={ |mp1,mp2,obj| nHandle:=0,PostAppEvent(xbeP_Close,,,oDlg) }
   oBut:caption:='Close'
   oBut:tabstop:=.t.
   oBut:create()

   AADD(aButtons,oBut)

   aPos  := {5,4}
   aSize := {60,32+15}
   oBox:=XbpStatic():new( oDlg:drawingArea, , aPos,aSize )
   oBox:type:=XBPSTATIC_TYPE_RECESSEDBOX
   oBox:paint:={ || ShowIcons(aPrograms,oDlg) }
   oBox:create()

   AADD(aPicture,oBox)

   oDlg:show()
   SetAppFocus(oDlg)
   SetAppFocus(oBut)

   aSize:={500,(Len(aPrograms)*47)+55}
   PostappEvent(xbeP_Resize,{1,1},aSize,oDlg)

   SetAppFocus(aButtons[LEN(aButtons)-1])
   PostappEvent(xbeP_Keyboard,xbeK_UP,,oDlg)

   nEvent := xbe_None
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp, )
      DO CASE
         CASE nEvent==xbeP_Keyboard .AND. mp1==xbeK_ESC
            EXIT

         CASE nEvent==xbeP_Keyboard .AND. mp1==xbeK_ENTER
            FindButton(aButtons,aPicture,xbeK_ENTER)

         CASE nEvent==xbeP_Keyboard .AND. mp1==xbeK_DOWN
            FindButton(aButtons,aPicture,xbeK_DOWN)

         CASE nEvent==xbeP_Keyboard .AND. mp1==xbeK_UP
            FindButton(aButtons,aPicture,xbeK_UP  )

         CASE nEvent==xbeP_Keyboard .AND. mp1==xbeK_TAB
            FindButton(aButtons,aPicture,xbeK_DOWN)

         CASE nEvent==xbeP_Keyboard .AND. mp1==xbeK_SH_TAB
            FindButton(aButtons,aPicture,xbeK_UP  )

      OTHERWISE
         oXbp:handleEvent( nEvent, mp1, mp2 )
      ENDCASE
   ENDDO
   oDlg:setModalState( XBP_DISP_MODELESS )
   oDlg:Destroy()

   IF nHandle!=0
      IF IsIconic(nHandle)!=0
         ShowWindow(nHandle,9)    // 9==SW_RESTORE
      ENDIF
      BringWindowToTop(nHandle)
      SetForegroundWindow(nHandle)
   ENDIF

RETURN

////////////////////////////////////////////////////////////////////////
STATIC PROCEDURE ShowIcons(aPrograms,oDlg)
LOCAL n, nDC
LOCAL iMax := Len(aPrograms)

FOR n:=1 TO iMax // Len(aPrograms)
    nDC := GetWindowDC(oDlg:gethWnd())
    IF n = iMax
       DrawIcon(nDC, 20, oDlg:drawingArea:currentSize()[2]-38, aPrograms[n,3])
    ELSE
       DrawIcon(nDC, 20, ((n-1)*47)+20+08, aPrograms[n,3])
    ENDIF
    ReleaseDC(oDlg:gethWnd(), nDC)
NEXT n
RETURN

////////////////////////////////////////////////////////////////////////
STATIC FUNCTION FindIcon(nHandle)
LOCAL nIcon
LOCAL ICON_SMALL:=0
LOCAL ICON_BIG:=1
LOCAL GCL_HICONSM:=-34
LOCAL GCL_HICON:=-14
LOCAL IDI_WINLOGO:=32517

   nIcon:=SendMessageA(nHandle, WM_GETICON, ICON_BIG, 0)
   if nIcon!=0
      RETURN nIcon
   endif

   nIcon:=SendMessageA(nHandle, WM_GETICON, ICON_SMALL, 0)
   if nIcon!=0
      RETURN nIcon
   endif

   nIcon:=GetClassLongA(nHandle, GCL_HICON)
   if nIcon!=0
      RETURN nIcon
   endif

   nIcon:=GetClassLongA(nHandle, GCL_HICONSM)
   if nIcon!=0
      RETURN nIcon
   endif

   nIcon:=LoadIconA( 0, IDI_WINLOGO )
RETURN nIcon

STATIC FUNCTION CenterWin(aSize)
LOCAL aRefSize, aCoors

   aRefSize := AppDeskTop():CurrentSize()
   aCoors   := { INT( (aRefSize[1] - aSize[1]) / 2 ) ,;
                 INT( (aRefSize[2] - aSize[2]) / 2 ) }

RETURN aCoors

STATIC FUNCTION GetWindowText( hWnd )
LOCAL nDll := DllLoad( "USER32.DLL" )
LOCAL xRet := DllCall( nDll, DLL_STDCALL, "GetWindowTextA", hWnd )
   DllUnLoad( nDll )
RETURN xRet

STATIC FUNCTION gettasklist( hWnd )
LOCAL aList       := {}
LOCAL cWindowName
LOCAL nVisible

   DO WHILE hWnd != 0
      cWindowname := SPACE( 100 )
      IF ( getwindowtexta( hWnd, @cWindowName, LEN( cWindowName ) ) <> 0 )
         nVisible := IsWindowVisible( hWnd )
         IF nVisible == 1
            AADD( aList, STR( hWnd, 8 ) + cWindowname )
         ENDIF
      ENDIF
      hWnd = GetWindow( hWnd, GW_HWNDNEXT )
   ENDDO
RETURN aList

STATIC FUNCTION GetWindow( hWnd, uCmd )
LOCAL nDll := DllLoad( "USER32.DLL" )
LOCAL xRet := DllCall( nDll, DLL_STDCALL, "GetWindow", hWnd, uCmd )
   DllUnLoad( nDll )
RETURN xRet

STATIC FUNCTION GetWindowTextA( hWnd, lPstring, nMax )
LOCAL nDll := DllLoad( "USER32.DLL" )
LOCAL xRet := DllCall( nDll, DLL_STDCALL, "GetWindowTextA", hWnd, @lPstring, nMax )
   DllUnLoad( nDll )
RETURN xRet

STATIC FUNCTION IsWindowVisible( hWnd )
LOCAL nDll := DllLoad( "USER32.DLL" )
LOCAL xRet := DllCall( nDll, DLL_STDCALL, "IsWindowVisible", hWnd )
   DllUnLoad( nDll )
RETURN xRet

STATIC PROCEDURE MainResize(aOldSize, aNewSize, oSelf)
LOCAL aChild
LOCAL aSize
LOCAL aPos
LOCAL i,iMax
LOCAL nButton := 0
LOCAL nHigh   := 0

   IF aOldSize[1] == 0 .AND. aOldSize[2] == 0               // New line
      aOldSize := aNewSize                                  // New line
      RETURN                                                // lieber Return ?

   ELSEIF aNewSize[1] == 0 .OR. aNewSize[2] == 0            // New line
      RETURN                                                // New line

   ELSEIF aNewSize[1] == aOldSize[1] .AND. aNewSize[2] == aOldSize[2]
      RETURN

   ENDIF                                                    // New line

   aChild := oSelf:drawingArea:Childlist()
   iMax   := LEN(aChild)

   nButton := (iMax-1)/2
   nHigh   := 47

   oSelf:drawingArea:LockUpdate(.T.)                      // New line
   aPos := CenterWin(aNewSize)
   oSelf:setPosAndSize(aPos,{aNewSize[1],aNewSize[2]})

   nButton := 0
   FOR i:= iMax-2 TO 1 STEP -1
      IF aChild[i]:isDerivedFrom( "XbpPushbutton" )

         aPos  := {70,oSelf:drawingArea:currentsize()[2]-(nHigh*nButton)-15}
         aSize := {oSelf:drawingArea:currentsize()[1]-75,nHigh}
         aChild[i]:setPosAndSize(aPos,aSize)

      ELSEIF aChild[i]:isDerivedFrom( "XbpStatic" )
         nButton++

         aPos  := { 5,oSelf:drawingArea:currentsize()[2]-(nHigh*nButton)-15}
         aSize := {60,nHigh}
         aChild[i]:setPosAndSize(aPos,aSize)
      ENDIF
   NEXT

   aPos  := {70,4}
   aSize := {oSelf:drawingArea:currentsize()[1]-75,nHigh}
   aChild[iMax-1]:setPosAndSize(aPos,aSize)

   aPos  := {5,4}
   aSize := {60,nHigh}
   aChild[iMax]:setPosAndSize(aPos,aSize)

   oSelf:drawingArea:LockUpdate(.F.)                      // New line
   oSelf:invalidateRect()

RETURN

STATIC PROCEDURE FindButton(aButtons,aPicture,xAktion)
LOCAL i,iMax

   iMax := LEN(aButtons)

   FOR i:= 1 TO iMax

      IF aButtons[i]:hasInputFocus()

         DO CASE
            CASE xAktion == xbeK_ENTER
               PostAppEvent(xbeP_Activate,,,aButtons[i])

            CASE xAktion == xbeK_UP
               aPicture[i]:setcolorBG(FarbeBG)
               aPicture[i]:type:=XBPSTATIC_TYPE_RAISEDBOX
               aPicture[i]:configure()

               i++
               IF i > iMax
                  i := 1
               ENDIF
               setAppFocus(aButtons[i])

               aPicture[i]:setcolorBG(GRA_CLR_GREEN)
               aPicture[i]:type:=XBPSTATIC_TYPE_RECESSEDBOX
               aPicture[i]:configure()

               EXIT


            CASE xAktion == xbeK_DOWN
               aPicture[i]:setcolorBG(FarbeBG)
               aPicture[i]:type:=XBPSTATIC_TYPE_RAISEDBOX
               aPicture[i]:configure()

               i--
               IF i <= 0
                  i := iMax
               ENDIF
               setAppFocus(aButtons[i])

               aPicture[i]:setcolorBG(GRA_CLR_GREEN)
               aPicture[i]:type:=XBPSTATIC_TYPE_RECESSEDBOX
               aPicture[i]:configure()
               EXIT
         ENDCASE

      ELSE
         aPicture[i]:setcolorBG(FarbeBG)
         aPicture[i]:type:=XBPSTATIC_TYPE_RAISEDBOX
         aPicture[i]:configure()
      ENDIF
   NEXT

RETURN

*
* eof
*